#include	"curses.ext"
#include	<sys/qnxterm.h>

/*	addch.c
 *
 *	Add a character to the current (x,y).
 */

int
waddch(REG WINDOW *win, SHORT c )

	{
	REG INT x, y;
	SHORT _space, c_attr;

	x = win->_curx;
	y = win->_cury;

	if (y >= win->_maxy || x >= win->_maxx || y < 0 || x < 0)
		return( ERR );

	c &= 0x00ff;
	c_attr = ( c | win->_attr );

	switch ( c )
		{
		case '\t':
			{
			REG INT newx;

			_space = _MTY_SPACE | win->_attr;
			for (newx = x + (8 - (x & 07)); x < newx; ++x)
				if (waddch( win, _space ) == ERR)
					return( ERR );

			return( OK );
			}
		default:
#ifdef __QNX__
			if (y == (term_state.num_rows-1) &&  x == (term_state.num_cols-1) && (! win->_scroll))
				return( ERR );
#else
			if (y == (tcap_entry.term_num_rows-1) &&  x == (tcap_entry.term_num_cols-1) && (! win->_scroll))
				return( ERR );
#endif
			if (win->_y[y][x] != c_attr)
				{
				if (win->_firstch[y] == _NOCHANGE)
					win->_firstch[y] = win->_lastch[y] = x;
				else if (x < win->_firstch[y])
					win->_firstch[y] = x;
				else if (x > win->_lastch[y])
					win->_lastch[y] = x;
				}
			win->_y[y][x++] = c_attr;
			if (x >= win->_maxx)
				{
				x = 0;
newline:
				if (++y >= win->_maxy)
					if (win->_scroll)
						{
						scroll( win );
						--y;
						}
					else
						return( ERR );
				}
			break;
		case '\n':
			wclrtoeol( win );
			x = 0;
			goto newline;
		case '\r':
			x = 0;
			break;
		case '\b':
			if (--x < 0)
				x = 0;
			break;
		}
	win->_curx = x;
	win->_cury = y;

	return( OK );
	}
