#include "curses.ext"

/*	color.c	
 *
 *	Set the attribute byte.
 */

/* the color and attributes byte

	7  6  5  4  3  2  1  0
	|  |  |  |  |  |  |  | 
	|  |  |  |  |  |  |  ------- bold (highlight)
	|  |  |  |  |  |  |  
	|  |  |  |  ---------------- background color OR attributes
	|  |  |  | 
	|  ------------------------- foreground color
	|
	---------------------------- SCRGRF flag

	where:  forground/background color and attribute are defined in CURSES.H
*/

void
wcolor(REG WINDOW *win,USHORT c)

	{
	win->_attr &= (~FG_COLORS);
	win->_attr |= (c & FG_COLORS);				/* foreground color */

	if( _en_color )
		{
		win->_attr &= (~BG_COLORS);
		win->_attr |= (c & BG_COLORS);			/* background color */
		}
	}
