/* curses.h   */

/*
#define ECHO			0x01
#define EDIT			0x02
#define ERS				0x08
*/
#define ESC				0x1b

#define _ATTR_NORMAL	0x7000
#define ENABLE_COLOR	0x8000
#define FG_COLORS		0x7000
#define BG_COLORS		0x0e00   /*was 0x0e00 */


#define NORMAL			0x7000
#define STANDOUT		0x0500
#define BLINK			0x0200
#define BOLD			0x0100
#define INVERSE			0x0400
#define UNDERLINE		0x0800
#define BG_BLACK		0x0000
#define BG_BLUE			0x0200
#define BG_GREEN		0x0400
#define BG_CYAN			0x0600
#define BG_RED			0x0800
#define BG_MAGENTA		0x0a00
#define BG_YELLOW		0x0c00
#define BG_WHITE		0x0e00
#define FG_BLACK		0x0000
#define FG_BLUE			0x1000
#define FG_GREEN		0x2000
#define FG_CYAN			0x3000
#define FG_RED			0x4000
#define FG_MAGENTA		0x5000
#define FG_YELLOW		0x6000
#define FG_WHITE		0x7000
#define GRAPHIC_CHAR	0x8000

#ifndef TRUE
#define TRUE	(1)
#define FALSE	(0)
#endif
#ifndef ERR
#define ERR		(0)
#endif
#ifndef OK
#define OK		(1)
#endif

#define _MTY_SPACE	0x0020
#ifndef CII
#define _NORMAL	00000
#endif
#define _SUBWIN	00001
#define _ENDLINE	00002
#define _FULLWIN	00004
#define _SCROLLWIN	00010
#define _NOCHANGE	-1

extern unsigned LINES, COLS;

struct _win_st {
	short	_cury, _curx;
	short	_maxy, _maxx;
	short	_begy, _begx;
	short	_flags;
	short	_attr;
	char	_clear;
	char	_scroll;
	short	**_y;
	short	*_firstch;
	short	*_lastch;
	struct	_st *_nextp, *_orig;
};

#define WINDOW struct _win_st

extern WINDOW *stdscr;
extern WINDOW  *initscr(), *newwin(), *subwin();

extern char *getcap();
extern unsigned _tty, _en_color;
extern char _echoit, _rawmode;


/*
 * psuedo functions
 */

#define clearok(win,bf)  (win->_clear = bf)
#define scrollok(win,bf) (win->_scroll = bf)
#define flushok(win,bf)  (bf ? (win->_attr |= FLUSH):(win->_attr &= ~FLUSH))
#define getyx(win,y,x)   (y = win->_cury, x = win->_curx)
#define winch(win)       (win->_y[win->_cury][win->_curx])

#ifndef __QNX__
#define raw()       (set_option(stdin,get_option(stdin) & ~EDIT), _rawmode=TRUE)
#define noraw()     (set_option(stdin,get_option(stdin) |  EDIT), _rawmode=FALSE)
#define crmode()    (set_option(stdin,get_option(stdin) & ~EDIT), _rawmode=TRUE)
#define nocrmode()  (set_option(stdin,get_option(stdin) |  EDIT), _rawmode=FALSE)
#define echo()      (set_option(stdin,get_option(stdin) |  ECHO), _echoit = TRUE)
#define noecho()    (set_option(stdin,get_option(stdin) & ~ECHO), _echoit = FALSE)
#define nl()        (set_option(stdin,get_option(stdin) |  ERS))
#define nonl()      (set_option(stdin,get_option(stdin) & ~ERS))
#define savetty()   {if(!_tty)_tty=get_option(stdin);_rawmode=FALSE;_echoit=TRUE;}
#define resetty()   {if(_tty){set_option(stdin,_tty);_rawmode=FALSE;_echoit=TRUE;}}
#else
#include <sys/dev.h>
#include <sys/qnxterm.h>

#define raw()       	(dev_mode(0,0,_DEV_EDIT), _rawmode=TRUE)
#define noraw()     	(dev_mode(0,_DEV_EDIT,_DEV_EDIT), _rawmode=FALSE)
#define crmode()       	(dev_mode(0,0,_DEV_EDIT), _rawmode=TRUE)
#define nocrmode()     	(dev_mode(0,_DEV_EDIT,_DEV_EDIT), _rawmode=FALSE)
#define echo()			(dev_mode(0,_DEV_ECHO,_DEV_ECHO), _echoit = TRUE)
#define noecho()    	(dev_mode(0,0,_DEV_ECHO), _echoit = FALSE)
#define nl()        	(dev_mode(0,_DEV_OPOST,_DEV_OPOST))
#define nonl()      	(dev_mode(0,0,_DEV_OPOST))
#define savetty()   	{if(!_tty)_tty=dev_mode(0,0,0);_rawmode=FALSE;_echoit=TRUE;}
#define resetty()   	{if(_tty){dev_mode(0,_tty,_DEV_MODES);_rawmode=FALSE;_echoit=TRUE;}}
#endif

#define wnormal(win)			(win->_attr =   NORMAL)
#define wblink(win)				{if(!_en_color) win->_attr |=  BLINK;}
#define wblinkend(win)			{if(!_en_color) win->_attr &= ~BLINK;}
#define wbold(win)				(win->_attr |=  BOLD)
#define wboldend(win)			(win->_attr &= ~BOLD)
#define wstandout(win)			(win->_attr |=  STANDOUT)
#define wstandend(win)			(win->_attr &= ~STANDOUT)
#define winverse(win)			{if(!_en_color) win->_attr |=  INVERSE;}
#define winverseend(win)		{if(!_en_color) win->_attr &= ~INVERSE;}
#define wunderline(win)			{if(!_en_color) win->_attr |=  UNDERLINE;}
#define wunderlineend(win)		{if(!_en_color) win->_attr &= ~UNDERLINE;}
#define wcolorend(win)			(wcolor(win,FG_WHITE|BG_BLACK))
#define wgraphic_char(win)		(win->_attr |=  GRAPHIC_CHAR)
#define wgraphic_charend(win)	(win->_attr &= ~GRAPHIC_CHAR)


/*
 * psuedo functions for standard screen
 */
#define addch(ch)			(waddch(stdscr, ch))
#define addstr(str)			(waddstr(stdscr, str))
#define blink()				{if(!_en_color) stdscr->_attr |=  BLINK;}
#define blinkend()			{if(!_en_color) stdscr->_attr &= ~BLINK;}
#define bold()				(stdscr->_attr |=  BOLD)
#define boldend()			(stdscr->_attr &= ~BOLD)
#define clear()				(wclear(stdscr))
#define clrtobot()			(wclrtobot(stdscr))
#define clrtoeol()			(wclrtoeol(stdscr))
#define color(c)			(wcolor(stdscr,(c)))
#define colorend()			(wcolor(stdscr,FG_WHITE|BG_BLACK))
#define delch()				(wdelch(stdscr))
#define deleteln()			(wdeleteln(stdscr))
#define erase()				(werase(stdscr))

#define wgetchar()				(wgetch(stdscr))
#define ungetchar(x)		term_unkey(x)	
#define getstr(str)			(wgetstr(stdscr, str))
#define inch()				(stdscr->_y[stdscr->_cury][stdscr->_curx])
#define insch(c)			(winsch(stdscr,c))
#define insertln()			(winsertln(stdscr))
#define inverse()			{if(!_en_color) stdscr->_attr |=  INVERSE;}
#define inverseend()		{if(!_en_color) stdscr->_attr &= ~INVERSE;}
#define move(y, x)			(wmove(stdscr, y, x))
#define refresh()			(wrefresh(stdscr))
#define normal()			(stdscr->_attr =   NORMAL)
#define standout()			(stdscr->_attr |=  STANDOUT)
#define standend()			(stdscr->_attr &= ~STANDOUT)
#define underline()			{if(!_en_color) stdscr->_attr |=  UNDERLINE;}
#define underlineend()		{if(!_en_color) stdscr->_attr &= ~UNDERLINE;}
#define graphic_char()		(stdscr->_attr |=  GRAPHIC_CHAR)
#define graphic_charend()	(stdscr->_attr &= ~GRAPHIC_CHAR)


/*
 * mv functions
 */
#define mvwaddch(win,y,x,ch)    (wmove(win,y,x)==ERR?ERR:waddch(win,ch))
#define mvwaddstr(win,y,x,str)  (wmove(win,y,x)==ERR?ERR:waddstr(win,str))
#define mvwdelch(win,y,x)       (wmove(win,y,x)==ERR?ERR:wdelch(win))
#define mvwgetch(win,y,x)       (wmove(win,y,x)==ERR?ERR:wgetch(win))
#define mvwgetstr(win,y,x)      (wmove(win,y,x)==ERR?ERR:wgetstr(win))
#define mvwinch(win,y,x)        (wmove(win,y,x)==ERR?ERR:(win->_y[win->_cury][win->_curx]))
#define mvwinsch(win,y,x,c)     (wmove(win,y,x)==ERR?ERR:winsch(win,c))
#define mvaddch(y,x,ch)         (wmove(stdscr,y,x)==ERR?ERR:waddch(stdscr,ch))
#define mvaddstr(y,x,str)       (wmove(stdscr,y,x)==ERR?ERR:waddstr(stdscr,str))
#define mvdelch(y,x)            (wmove(stdscr,y,x)==ERR?ERR:wdelch(stdscr))
#define mvgetch(y,x)            (wmove(stdscr,y,x)==ERR?ERR:wgetch(stdscr))
#define mvgetstr(y,x)           (wmove(stdscr,y,x)==ERR?ERR:wgetstr(stdscr))
#define mvinch(y,x)             (wmove(stdscr,y,x)==ERR?ERR:stdscrch(stdscr))
#define mvinsch(y,x,c)          (wmove(stdscr,y,x)==ERR?ERR:stdscrsch(stdscr,c))
/* protos */

extern int waddch(struct _win_st *,short );
extern int waddstr(struct _win_st *,char *);
extern void box(struct _win_st *,short ,short );
extern int wclear(struct _win_st *);
extern int wclrtobot(struct _win_st *);
extern void wclrtoeol(struct _win_st *);
extern void wcolor(struct _win_st *,unsigned short );
extern void clear_screen(void);
extern void mvcur(char ,char );
extern int wdelch(struct _win_st *);
extern void wdeleteln(struct _win_st *);
extern int delwin(struct _win_st *);
extern unsigned int en_color(void);
extern void endwin(void);
extern void werase(struct _win_st *);
extern int wgetch(struct _win_st *);
extern int wgetstr(struct _win_st *,char *);
extern struct _win_st *initscr(void);
extern void setterm(void );
extern int winsch(struct _win_st *,int );
extern int winsertln(struct _win_st *);
extern int wmove(struct _win_st *,int ,int );
extern int mvprintw(short ,short ,char *,... );
extern int mvwprintw(struct _win_st *,short ,short ,char *,... );
extern int mvscanw(int ,int ,char *, ...);
extern int mvwscanw(struct _win_st *,int ,int ,char *,... );
/*
extern int mvtprintw(int ,int ,char *, ...);
extern int mvwtprintw(struct _win_st *,int ,int ,char *);
extern int mvtscanw(int ,int ,char *);
extern int mvwtscanw(struct _win_st *,int ,int ,char *);
extern int tprintw(char *);
extern int wtprintw(struct _win_st *,char *);
extern int wtscanw(struct _win_st *,char *);
extern int tscanw(char *);
*/
extern int mvwin(struct _win_st *,int ,int );
extern struct _win_st *newwin(int ,int ,int ,int );
extern struct _win_st *subwin(struct _win_st *,int ,int ,int ,int );
extern void overwrite(struct _win_st *,struct _win_st *);
extern void overlay(struct _win_st *,struct _win_st *);
extern int printw(char *,... );
extern int wprintw(struct _win_st *,char *,... );
extern int wrefresh(struct _win_st *);
extern int scanw(char *,...);
extern int wscanw(struct _win_st *,char *, ...);
extern int scroll(struct _win_st *);
extern void touchwin(struct _win_st *);
extern void _cl_touchwin(struct _win_st *);
