#include <stdio.h>
#include <sys/console.h>
#include <fcntl.h>
#include <sys/qnxterm.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include	"curses.ext"

/*	initscr.c
 *
 *	Initialize the screen and variables.  This should always be
 *	the first "curses" function called.  It determines screen size
 *	and makes sure the frist call to refresh will clear the screen.
 *
 *		Define global variables
 */

/*
 * Capabilities from termcap

extern BOOL		AM, BS, CA, DA, DB, EO, GT, HZ, IN, MI, MS, NC, OS, UL, XN;
extern CHAR		*AL, *BC, *BT, *CD, *CE, *CL, *CM, *CR, *DC, *DL, *DM,
		*DO, *ED, *EI, *HO, *IC, *IM, *IP, *LL, *MA, *ND, *NL,
		*SE, *SF, *SO, *SR, *TA, *TE, *TI, *UC, *UE, *UP, *US,
		*VB, *VE, *VS, PC;
 */


WINDOW	*
initscr()
	{
	if(isatty( 1 ))
		savetty();

	setterm();

	delwin( stdscr );

	if( stdscr = newwin( LINES, COLS, 0, 0 ) )
		wclear( stdscr );

	return( stdscr );
	}

#ifndef __QNX__
unsigned My_Device;
#endif
void
setterm(void)
	{
	UINT en_color();
    int fd;
    struct _console_ctrl *cc;
	static CHAR loaded;

	if ( ! loaded )
		{
#ifdef __QNX__
		if ( term_load() == -1 ) {
#else
		if ( ! term_load( stderr ) ) 
#endif
#ifdef __QNX__
			fprintf(stderr, "initscr: Unable to load terminal entry (%d)\n",errno );
			exit(-1);
			}
#else
			abort( "initscr: Unable to load terminal entry\\n" );
#endif
		loaded = TRUE;
		}
#ifdef __QNX__
    fd = open("/dev/con1",O_RDWR);
    cc = console_open(fd,O_RDWR);
    close(fd);

    console_size(cc,-1,0,0,(int *)&LINES,(int *)&COLS);
    console_close(cc);
/*
	LINES = term_state.num_rows;
	COLS = term_state.num_cols;
*/
#else
	if ( ! tcap_entry.term_type )
		{
		My_Device = fdevno(stderr);
		n = video_get_size( My_Device );
		LINES = (n >> 8) & 0xff;
		COLS = n & 0xff;
		}
	else
		{
		LINES = tcap_entry.term_num_rows;
		COLS = tcap_entry.term_num_cols;
		}
#endif
	_en_color = en_color();
	}
