#include	"curses.ext"

/*	overwrite.c
 *
 *	Write win1 on win2 destructively.
 */

void
overwrite( win1, win2 )
REG WINDOW *win1, *win2;
	{
	REG INT x;
	INT y, minx, miny, starty;

	miny = min( win1->_maxy, win2->_maxy );
	minx = min( win1->_maxx, win2->_maxx );

	starty = win1->_begy - win2->_begy;
	for (y = 0; y < miny; ++y)
		if (wmove( win2, y + starty, 0 ) != ERR)
			for (x = 0; x < minx; ++x)
				waddch( win2, win1->_y[y][x] );
	}


/*
 *	overlay.c
 *
 *	Write win1 on win2 non-destructively.  White space is not written.
 */

void
overlay( win1, win2 )
REG WINDOW *win1, *win2;
	{
	REG INT x;
	INT y, minx, miny, starty;
	SHORT c;

	miny = min( win1->_maxy, win2->_maxy );
	minx = min( win1->_maxx, win2->_maxx );

	starty = win1->_begy - win2->_begy;
	for (y = 0; y < miny; ++y)
		if (wmove( win2, y + starty, 0 ) != ERR)
			for (x = 0; x < minx; ++x)
				{
				c = (win1->_y[y][x] & 0x00ff);
				if (!isspace( c ))
					mvwaddch( win2, y + starty, x, c );
				}
	}
